DROP TABLE IF EXISTS sacoche_parametre;

CREATE TABLE sacoche_parametre (
  parametre_nom    VARCHAR(50)  COLLATE utf8_unicode_ci NOT NULL DEFAULT "",
  parametre_valeur VARCHAR(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT "",
  PRIMARY KEY (parametre_nom)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

ALTER TABLE sacoche_parametre DISABLE KEYS;

INSERT INTO sacoche_parametre VALUES 
( "acquis_legende_A"                                 , "Acquis." ),
( "acquis_legende_NA"                                , "Non acquis." ),
( "acquis_legende_VA"                                , "Partiellement acquis." ),
( "acquis_texte_A"                                   , "A" ),
( "acquis_texte_NA"                                  , "NA" ),
( "acquis_texte_VA"                                  , "VA" ),
( "calcul_limite"                                    , "5" ),
( "calcul_methode"                                   , "geometrique" ),
( "calcul_retroactif"                                , "oui" ),
( "calcul_seuil_R"                                   , "40" ),
( "calcul_seuil_V"                                   , "60" ),
( "calcul_valeur_R"                                  , "33" ),
( "calcul_valeur_RR"                                 , "0" ),
( "calcul_valeur_V"                                  , "67" ),
( "calcul_valeur_VV"                                 , "100" ),
( "cas_serveur_host"                                 , "" ),
( "cas_serveur_port"                                 , "" ),
( "cas_serveur_root"                                 , "" ),
( "cas_serveur_url_login"                            , "" ),
( "cas_serveur_url_logout"                           , "" ),
( "cas_serveur_url_validate"                         , "" ),
( "connexion_departement"                            , "" ),
( "connexion_mode"                                   , "normal" ),
( "connexion_nom"                                    , "sacoche" ),
( "css_background-color_A"                           , "#99ff99" ),
( "css_background-color_NA"                          , "#ff9999" ),
( "css_background-color_VA"                          , "#ffdd33" ),
( "date_last_import_eleves"                          , "0000-00-00" ),
( "date_last_import_parents"                         , "0000-00-00" ),
( "date_last_import_professeurs"                     , "0000-00-00" ),
( "deconnexion_adresse_redirection"                  , "" ),
( "droit_affecter_langue"                            , "DIR,ENS,ONLY_LV" ),
( "droit_annulation_pilier"                          , "DIR" ),
( "droit_fiche_brevet_appreciation_generale"         , "DIR" ),
( "droit_fiche_brevet_corriger_appreciation"         , "DIR" ),
( "droit_fiche_brevet_impression_pdf"                , "DIR" ),
( "droit_fiche_brevet_modifier_statut"               , "DIR" ),
( "droit_fiche_brevet_voir_archive"                  , "DIR,ENS,DOC,EDU" ),
( "droit_gerer_referentiel"                          , "ENS,DOC,EDU,ONLY_COORD" ),
( "droit_gerer_ressource"                            , "ENS,DOC,EDU" ),
( "droit_modifier_email"                             , "DIR,ENS,DOC,EDU,TUT,ELV" ),
( "droit_modifier_mdp"                               , "DIR,ENS,DOC,EDU,TUT,ELV" ),
( "droit_officiel_bulletin_appreciation_generale"    , "DIR,ENS,ONLY_PP" ),
( "droit_officiel_bulletin_corriger_appreciation"    , "DIR" ),
( "droit_officiel_bulletin_impression_pdf"           , "DIR" ),
( "droit_officiel_bulletin_modifier_statut"          , "DIR" ),
( "droit_officiel_bulletin_voir_archive"             , "DIR,ENS,DOC,EDU" ),
( "droit_officiel_releve_appreciation_generale"      , "DIR,ENS,ONLY_PP" ),
( "droit_officiel_releve_corriger_appreciation"      , "DIR" ),
( "droit_officiel_releve_impression_pdf"             , "DIR" ),
( "droit_officiel_releve_modifier_statut"            , "DIR" ),
( "droit_officiel_releve_voir_archive"               , "DIR,ENS,DOC,EDU" ),
( "droit_officiel_saisir_assiduite"                  , "DIR,EDU" ),
( "droit_officiel_socle_appreciation_generale"       , "DIR,ENS,ONLY_PP" ),
( "droit_officiel_socle_corriger_appreciation"       , "DIR" ),
( "droit_officiel_socle_impression_pdf"              , "DIR" ),
( "droit_officiel_socle_modifier_statut"             , "DIR" ),
( "droit_officiel_socle_voir_archive"                , "DIR,ENS,DOC,EDU" ),
( "droit_releve_conversion_sur_20"                   , "" ),
( "droit_releve_etat_acquisition"                    , "TUT,ELV" ),
( "droit_releve_moyenne_score"                       , "TUT,ELV" ),
( "droit_releve_pourcentage_acquis"                  , "TUT,ELV" ),
( "droit_socle_acces"                                , "TUT,ELV" ),
( "droit_socle_etat_validation"                      , "" ),
( "droit_socle_pourcentage_acquis"                   , "TUT,ELV" ),
( "droit_validation_entree"                          , "DIR,ENS,DOC,EDU" ),
( "droit_validation_pilier"                          , "DIR,ENS,ONLY_PP" ),
( "droit_voir_algorithme"                            , "DIR,ENS,DOC,EDU,TUT,ELV" ),
( "droit_voir_etat_acquisition_avec_evaluation"      , "" ),
( "droit_voir_grilles_items"                         , "DIR,ENS,DOC,EDU,TUT,ELV" ),
( "droit_voir_referentiels"                          , "DIR,ENS,DOC,EDU,TUT,ELV" ),
( "droit_voir_score_bilan"                           , "DIR,ENS,DOC,EDU,TUT,ELV" ),
( "enveloppe_horizontal_droite"                      , "20" ),
( "enveloppe_horizontal_gauche"                      , "110" ),
( "enveloppe_horizontal_milieu"                      , "100" ),
( "enveloppe_vertical_bas"                           , "20" ),
( "enveloppe_vertical_haut"                          , "50" ),
( "enveloppe_vertical_milieu"                        , "45" ),
( "etablissement_adresse1"                           , "" ),
( "etablissement_adresse2"                           , "" ),
( "etablissement_adresse3"                           , "" ),
( "etablissement_courriel"                           , "" ),
( "etablissement_denomination"                       , "" ),
( "etablissement_fax"                                , "" ),
( "etablissement_langue"                             , "fr_FR" ),
( "etablissement_telephone"                          , "" ),
( "etablissement_url"                                , "" ),
( "gepi_certificat_empreinte"                        , "" ),
( "gepi_rne"                                         , "" ),
( "gepi_url"                                         , "" ),
( "liste_paliers_actifs"                             , "" ),
( "mois_bascule_annee_scolaire"                      , "8" ),
( "note_image_RR"                                    , "disque-double_rouge" ),
( "note_image_R"                                     , "disque_rouge" ),
( "note_image_V"                                     , "disque_vert-fonce" ),
( "note_image_VV"                                    , "disque-double_vert-fonce" ),
( "note_legende_RR"                                  , "Très insuffisant." ),
( "note_legende_R"                                   , "Insuffisant." ),
( "note_legende_V"                                   , "Satisfaisant." ),
( "note_legende_VV"                                  , "Très satisfaisant." ),
( "note_texte_RR"                                    , "RR" ),
( "note_texte_R"                                     , "R" ),
( "note_texte_V"                                     , "V" ),
( "note_texte_VV"                                    , "VV" ),
( "officiel_archive_ajout_message_copie"             , "1" ),
( "officiel_archive_retrait_tampon_signature"        , "1" ),
( "officiel_bulletin_acquis_texte_code"              , "1" ),
( "officiel_bulletin_acquis_texte_nombre"            , "1" ),
( "officiel_bulletin_appreciation_generale_longueur" , "400" ),
( "officiel_bulletin_appreciation_generale_report"   , "" ),
( "officiel_bulletin_appreciation_generale_modele"   , "" ),
( "officiel_bulletin_appreciation_rubrique_longueur" , "400" ),
( "officiel_bulletin_appreciation_rubrique_report"   , "" ),
( "officiel_bulletin_appreciation_rubrique_modele"   , "" ),
( "officiel_bulletin_assiduite"                      , "0" ),
( "officiel_bulletin_barre_acquisitions"             , "1" ),
( "officiel_bulletin_conversion_sur_20"              , "1" ),
( "officiel_bulletin_couleur"                        , "oui" ),
( "officiel_bulletin_fond"                           , "gris" ),
( "officiel_bulletin_fusion_niveaux"                 , "1" ),
( "officiel_bulletin_legende"                        , "oui" ),
( "officiel_bulletin_ligne_supplementaire"           , "" ),
( "officiel_bulletin_moyenne_classe"                 , "1" ),
( "officiel_bulletin_moyenne_exception_matieres"     , "" ),
( "officiel_bulletin_moyenne_generale"               , "0" ),
( "officiel_bulletin_moyenne_scores"                 , "1" ),
( "officiel_bulletin_only_socle"                     , "0" ),
( "officiel_bulletin_prof_principal"                 , "0" ),
( "officiel_bulletin_retroactif"                     , "non" ),
( "officiel_infos_etablissement"                     , "denomination,adresse,telephone,fax,courriel,url" ),
( "officiel_infos_responsables"                      , "non" ),
( "officiel_marge_bas"                               , "10" ),
( "officiel_marge_droite"                            , "5" ),
( "officiel_marge_gauche"                            , "5" ),
( "officiel_marge_haut"                              , "5" ),
( "officiel_nombre_exemplaires"                      , "un" ),
( "officiel_releve_aff_coef"                         , "0" ),
( "officiel_releve_aff_domaine"                      , "0" ),
( "officiel_releve_aff_socle"                        , "1" ),
( "officiel_releve_aff_theme"                        , "0" ),
( "officiel_releve_appreciation_generale_longueur"   , "400" ),
( "officiel_releve_appreciation_generale_report"     , "" ),
( "officiel_releve_appreciation_generale_modele"     , "" ),
( "officiel_releve_appreciation_rubrique_longueur"   , "400" ),
( "officiel_releve_appreciation_rubrique_report"     , "" ),
( "officiel_releve_appreciation_rubrique_modele"     , "" ),
( "officiel_releve_assiduite"                        , "0" ),
( "officiel_releve_cases_nb"                         , "4" ),
( "officiel_releve_conversion_sur_20"                , "0" ),
( "officiel_releve_couleur"                          , "oui" ),
( "officiel_releve_fond"                             , "gris" ),
( "officiel_releve_etat_acquisition"                 , "1" ),
( "officiel_releve_legende"                          , "oui" ),
( "officiel_releve_ligne_supplementaire"             , "" ),
( "officiel_releve_moyenne_scores"                   , "1" ),
( "officiel_releve_only_socle"                       , "0" ),
( "officiel_releve_pages_nb"                         , "optimise" ),
( "officiel_releve_pourcentage_acquis"               , "1" ),
( "officiel_releve_prof_principal"                   , "0" ),
( "officiel_releve_retroactif"                       , "non" ),
( "officiel_socle_appreciation_generale_longueur"    , "400" ),
( "officiel_socle_appreciation_generale_report"      , "" ),
( "officiel_socle_appreciation_generale_modele"      , "" ),
( "officiel_socle_appreciation_rubrique_longueur"    , "0" ),
( "officiel_socle_appreciation_rubrique_report"      , "" ),
( "officiel_socle_appreciation_rubrique_modele"      , "" ),
( "officiel_socle_assiduite"                         , "0" ),
( "officiel_socle_couleur"                           , "oui" ),
( "officiel_socle_fond"                              , "gris" ),
( "officiel_socle_etat_validation"                   , "1" ),
( "officiel_socle_legende"                           , "oui" ),
( "officiel_socle_ligne_supplementaire"              , "" ),
( "officiel_socle_only_presence"                     , "0" ),
( "officiel_socle_pourcentage_acquis"                , "1" ),
( "officiel_socle_prof_principal"                    , "0" ),
( "officiel_tampon_signature"                        , "signature_ou_tampon" ),
( "sesamath_id"                                      , "0" ),
( "sesamath_key"                                     , "" ),
( "sesamath_type_nom"                                , "" ),
( "sesamath_uai"                                     , "" ),
( "version_base"                                     , "" ),
( "webmestre_denomination"                           , "" ),
( "webmestre_uai"                                    , "" );

ALTER TABLE sacoche_parametre ENABLE KEYS;
